

function init()

	-- target speed
	targetSpeed = 18.8 -- idealy this should be 7 (the normal movement velocity in teardown) and perFrameMult should be something like 128, however
	-- that causes issues with speed buildup which causes the whole thing to bug out and send the player flying into the air at mach 50
	perFrameMult = 24 -- jank, to counter friction, basically accleration
	-- Actual current speed
	playerForwardVelocity = 0
	playerRightVelocity = 0
	
	timeScale = 1
	
	timeScaleLerp = 1
	
	doFlashSpeed = false
	timeChangeSound = LoadSound("timechange_cool.ogg")
end
	

	
function tick(dt)
	-- time scale
	if InputPressed("t") then
		doFlashSpeed = not doFlashSpeed
		PlaySound(timeChangeSound)
		if doFlashSpeed then
			timeScale = 0.1

		else
			timeScale = 1
		end
	end
	
	-- lerping
	if doFlashSpeed and timeScaleLerp ~= 1 then
		timeScaleLerp = math.min(timeScaleLerp + (dt * 3), 1)
	elseif not doFlashSpeed and timeScaleLerp ~= 0 then
		timeScaleLerp = math.max(timeScaleLerp - dt, 0)
	end
	
	-- only execute if we want to do flash speed
	if doFlashSpeed and timeScaleLerp ~= 0 then
		SetTimeScale((0.1 * (timeScaleLerp*3)) + (1 * (1-(timeScaleLerp*3))))

		-- get signed relative velocities
		local playerVelVector = GetPlayerVelocity() -- get the velocity of the player and then transform to local so we have signed velocity on forward and right. this will be the backbone of the "faux" modified movement code
		local modifiedTransform = GetPlayerCameraTransform() -- for some reason the normal player transfrom doesn't seem to give the correct yaw, 
		-- so we need to take the camera transform and zero out pitch, then transform to local from that
		local ex, ey, ez = GetQuatEuler(modifiedTransform.rot)	
		ex = 0 -- set pitch to zero
		modifiedTransform.rot = QuatEuler(ex, ey, ez) -- set the rot of the modified transform to the modified rotation
		local transformedPlayerVelVector = TransformToLocalVec(modifiedTransform, playerVelVector) -- apply modified transform to velocity
		playerForwardVelocity = 0 - transformedPlayerVelVector[3] -- set forward and right signed velocities
		playerRightVelocity = transformedPlayerVelVector[1]
		
		-- get input
		local forward = 0 -- remember that forward is inverted from what you'd expect
		local right = 0
		
		if InputDown("up") then
			forward = forward + 1
		end
		if InputDown("down") then
			forward = forward - 1
		end
		if InputDown("right") then
			right = right + 1
		end
		if InputDown("left") then
			right = right - 1
		end
		
		-- get forward and right vectors for velocity adding
		local playerForwardVector = TransformToParentVec(modifiedTransform, Vec(0,0,-1)) -- forward is -1 on z relative to transform
		local playerRightVector = TransformToParentVec(modifiedTransform, Vec(1,0,0)) -- right is 1 on x relative to transform
		
		-- hardcoding the inverse sqrt of 2 because sqrting numbers causes the game to hang for some reason
		local axisMag = (forward ~= 0 and right ~= 0) and 0.7071067811865 or 1
		
		-- scaledTargetSpeed so that our move speed is independent of time
		local scaledTargetSpeed = targetSpeed/timeScale
		local scaledPerFrameMult = perFrameMult/timeScale
		
		-- apply added velocity
		playerVelVector = VecAdd(playerVelVector, VecScale(playerForwardVector, math.min(60, math.max(-60,((targetSpeed * forward * axisMag)- playerForwardVelocity)   * dt * scaledPerFrameMult * (timeScaleLerp*timeScaleLerp) ))))
		playerVelVector = VecAdd(playerVelVector, VecScale(playerRightVector, math.min(60, math.max(-60,((targetSpeed* right * axisMag) - playerRightVelocity )  * dt * scaledPerFrameMult * (timeScaleLerp*timeScaleLerp)))))
		

		SetPlayerVelocity(playerVelVector)
		

	end
end


function update(dt)

end


function draw(dt)
	if doFlashSpeed then
		UiPush()
			UiTranslate(UiWidth()/24,UiHeight()/24)
			UiAlign("left top")
			UiColor(1,1,1)
			UiFont("bold.ttf", 48)
			UiText("Speed Force Enabled", true)
			--UiText(playerRightVelocity, true)
			--UiText("Current Time Scale: "..timeScale, true)
		UiPop()
	end
end

